module Min where

import Data.Monoid

newtype Min a = Min { getMin :: a }

instance (Bounded a, Ord a) => Monoid (Min a) where
  mempty = Min maxBound
  (Min a) `mappend` (Min b) = Min (a `min` b)
  mconcat = Min . maximum . map getMin


