{-# LANGUAGE ViewPatterns #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
module Test
  ( Test(..)
  , test
  ) where

import Control.Applicative hiding ((<|>))
import Data.Maybe
import Data.List

data Test
  = Test
  { modu :: String
  , preOptions :: [String]
  , cmd :: String
  , postOptions :: [String]
  }
 deriving Show

test :: Test
test = Test
     { modu = error "No modu set!"
     , preOptions = []
     , cmd = "source"
     , postOptions = ["--ghc-options=-fforce-recomp"]
     }
