module Max where

import Data.Monoid

newtype Max a = Max { getMax :: a }

instance (Bounded a, Ord a) => Monoid (Max a) where
  mempty = Max minBound
  (Max a) `mappend` (Max b) = Max (a `max` b)
  mconcat = Max . maximum . map getMax

