module Tests where

import Test

tests :: [Test]
tests = [error0, oom, oot, ioprim]

error0 :: Test
error0 
  = test { modu = "Error0"
         , preOptions = ["--trace", "-d", "--ai-source", "--depth=5"]
         }

oom :: Test
oom
  = test { modu = "OOM"
         , preOptions = ["--trace", "--expressionAllocs=5", "--expressionTime=1000000", "-d", "--ai-source", "--depth=5"]
         }

oot :: Test
oot
  = test { modu = "OOT"
         , preOptions = ["--trace", "--expressionAllocs=1000000", "--expressionTime=5", "-d", "--ai-source", "--depth=5"]
         }

ioprim :: Test
ioprim
  = test { modu = "IOPrim"
         , preOptions = ["--trace", "--depth=20", "-d"]
         }
